/**
 * @(#)Simulation_3Agents.java
 * 
 * @author Chris Papageorakis
 * @version 1.00 2011/10/15
 */
import java.util.*;

public class Simulation_3Agents {
 
 
 public static int n2=8;		//number of nodes (n) at the ring
 public static int k=3; 		//number of Agents
 public static int M=1; 		//number of Black Holes
 
 public static int RandomRing=1;			//If value is 1 the ring takes a random size, 0 ring size is the default.
 public static int RandomAgentsPositions=1;	//If value is 1 the agents has different and random positions, 0 agents positions are the default.
 public static int PrintMethod=1;			//Chooses the print Method, 1 prints as ring and 2 prints as array. 
 
 public static long clock=0;	//time units, clock	
 public static int BHfound=0; 	//flag for stopping the execution
 public static int flag=0;
 public static int BH=0;  		//positions at the position Array. used at printRing
 public static int A1=1;
 public static int A2=2;
 public static int A3=3;
 
 public static int map[]=new int[k]; //all agent has the same map with agents ID as [x] and position as map[x]
 public static int d[]=new int[k+1]; //distances: d[1] is d1... d[3] is d3, d[0] null but used later
 public static int mapDirection=1;   //is the direction all agents agree
 
 	public static void main (String[] args) {
		int positions[]=new int[k+M]; //0 BH, 1 agent1, 2 agent2, 3 agent3
		int tempPos[]=new int[k+M]; //same as positions Array. Used for better synchronous model
		int AgData[][]=new int[k+M][9];  	//x-> 0 null 1 Agent1 2 Agent2....
		InitArray(AgData);				    //y-> 0 phase of CWalk 1 MINid  2 flag for MINid 3 flag for wait,move or MoveTogether
    								    //    4 delay 		   5 phase  6 dir  			 7 MoveT phase  8 BHfound per agent
		InitArray(positions);
		//Use it for manual input of agents position
		positions[0]=1;	//BH 	 position
		positions[1]=4;		//Agent1 position
		positions[2]=0;		//Agent2 position
		positions[3]=5;	//Agent3 position
		//Warning: positions must be smaller than n
		
		if(checkPositions(positions)==-1){System.err.println("Error at start positions, n<4"); return;}
		if(RandomRing==1){ RandRingSize();	}
		if(RandomAgentsPositions==1){	RandAgents(positions);	}
		
		findDirection(positions);
		if(mapDirection>0){System.out.println("Direction is: +\n");}
    	else{System.out.println("Direction is: -\n");}
    	
		UpdatePos(positions, tempPos);//inits the tempPos with positions Array
		if(checkPositions(positions)==0){
			simulationAll(positions, AgData, tempPos);  }
 	   else{
 		   	System.err.println("Error at start positions");}
	}//end of main
    
    
    //--------------------------Basic functions---------------------------------------------------------------------
    public static void InitArray(int A[]){ //Initialazation of an array
    	int i;
		for(i=0;i<A.length; i++ ){A[i]=0;}
    }//end of InitArray
    
    public static void InitArray(int A[][]){//Initialazation of an 2D array
    	int i,j;
		for(i=0;i<A.length; i++ ){
			for(j=0;j<A[0].length; j++){
				A[i][j]=0;
			}
		}
    }//end of InitArray2D
    
    public static void PrintArray(int A[]){
    	int i;
    	for(i=0;i<A.length;i++){
    		System.out.printf("%d \t",A[i]);}
    		System.out.printf("\n \n");
    }//end of PrintArray
    
    public static void swap(int A[], int x, int y){//swap the values A[x],A[y]
    	int t=0;
    	t=A[x];
    	A[x]=A[y];
    	A[y]=t;
    	}   
    
    public static int Uinput(){ //read users input from the keyboard
    	int f=-1;
		Scanner s=new Scanner(System.in);
		try{
			f=s.nextInt();
		}catch( Exception e){}
    	if(f==-1){System.err.println("Uinput returned -1");}	
    		return f;
    }//end of input
    
    public static void UpdatePos(int A1[], int A2[]){ //copies the A1 Array elements to the A2 Array
    	//For most cases A1 will be the tempPos Array and A2 will be the positions Array
    	int i;
		for(i=0;i<A1.length; i++ ){A2[i]=A1[i];}
    }//end of UpdatePos
    
    public static int Min(int A[],int start){
    	//returns where is the min value of an array A
    	//start is the start position of this function at the array(1 if we want to skip BHs position).
    	int i,min,th;
    	min=A[start];
    	th=start;
    	for(i=start+1;i<A.length; i++){
    		if(A[i]<min){	min=A[i]; th=i;	}
    	}
    	return 	th;
    }//end of Min
    
    public static int Max(int A[],int start){
     	//returns where is the max value of an array A
    	//start is the start position of this function at the array.
    	int i,max,th;
    	max=A[start];
    	th=start;
    	for(i=start+1;i<A.length; i++){
    		if(A[i]>max){	max=A[i]; th=i;	}
    	}
    	return th;		
    }//end of Max
    
    public static int MAX(int a, int b){//returns the maximum between 2 integers
    	if(a>b){return a;}
    	else{return b;}
    }//end if MAX
    
    
 //--------------------------Simulation functions---------------------------------------------------------------------
    
    public static int checkPositions(int P[]){//Checks if positions are smaller than the nubber of nodes.
    //If agents positions are right returns 0, if not returns 1. If n<4 return -1.
    	if(n2<4){return -1;}
    	int i;
		for(i=0;i<P.length; i++ ){
			if(P[i]>=n2){
				System.err.println("Position bigger than size of ring");
				return 1;
			}
		}
		return 0;
    }//end of checkPositions
    
    public static void RandRingSize(){
    	Random diceRoller = new Random();
			int roll = diceRoller.nextInt(25);
			n2=roll+4;
			System.out.println("Size of ring (n) is:" + n2);
    }//end of RandRingSize
    
    public static void uniqueValues(int P[], int v, int k){ //Makes unique and random values. for example: IDs, Positions.
    //input: The array to be filled with unique values, values between 0 and v, k size of array
    //Uses the global n2. k is overridden.
    	Random diceRoller = new Random();
		int roll=-1,i=0,j,flag=0;
		int A[]=new int[k+1];
    	while(i<=k){
    		if(i==0){A[i]=diceRoller.nextInt(v); i++;}
    		else{j=0; flag=0;
    			roll = diceRoller.nextInt(v);
    			while(j<i){		//ensures that all agent will have different positions
    				if(roll==A[j]){flag=1; break;}
    				else{j++;}
    			}
    			if(flag==0){A[i]=roll; i++;}
    		}
    	}
    	for(i=0;i<=k;i++){	P[i]=A[i];	}  
    }//end of uniqueValues
    
    public static void AgentLabeling(int P[], int IDs[]){//label agents from random IDs to A1,...,An
    	int i,th=-1,temp=-1;
    	i=1;
    		th=Min(IDs,i-1); //Min Agent ID 
    		swap( IDs,i-1,th );
    		swap( P, i, th+1 );
    	i=2;
    		th=Max(IDs,i-1); //Min Agent ID 
    		swap( IDs, i-1 ,th );
    		swap( P, i,th+1 );
    }//end of AgentLabeling
    
    public static void findDirection(int P[]){//Agents use this function to agree at the direction of ring
    	//input is the map
    	int i,fl=0;
    	i=P[1];
    	while(fl==0){
    		if(i==P[2]){ mapDirection=1; fl=1; break; }
    		if(i==P[3]){ mapDirection=-1; fl=1; break; }
    		
    		if(i==n2-1)	{ i=0;	}
    		else		{ i=i+1;}
    	}
    }//end of findDirection
    
    public static void RandAgents(int P[]){//This functions returns random agent positions and Ids
    	int IDs[]=new int[k],i;  
    	System.out.println("Random positions:");
    	uniqueValues(P, n2, k);  		//makes unique and random positions. [0] is BH position!!
    	for(i=0;i<=k;i++){
    	  if(i==0){	System.out.printf("BH:%d \t",P[i]);			}
    	  else{		System.out.printf("A%d:%d \t",i,P[i]);		}
    	}
    	System.out.println("\n");

    	System.out.printf("Random IDs:\n \t\t");
    	uniqueValues(IDs, 10000, k-1);   //makes unique and random IDs  [0] is fistr ID P[1] is the fist agent position
    	for(i=0;i<=k-1;i++){	System.out.printf("A%d:%d \t",i+1,P[i]);	}
    	System.out.println("\n");
    	
    	AgentLabeling(P, IDs); 
    }//end of RandAgents
    
    public static int distance(int Agent, int dir){//Finds the distance in a ring between one agent to the other agent CW
    	//input is the agent starting measuring the distance
    	//map direction
    	int Agent1=Agent-1,Agent2=-1,d=-1,th;
    	
    	if(Agent>k-1){	Agent2=0;	}
    	else{	Agent2=Agent;	}
    	th=map[Agent1];
    	d=0;
    	while(map[Agent2]!=th){
    		d=d+1;
    		if(dir==1){
    			if(th>=n2-1){th=0;}
    			else{th=th+1;}
    		}
    		if(dir==-1){
    			if(th<=0){th=n2-1;}
    		 	else{th=th-1;}
    		}
    	}
    	return d;
    }//end of distance

    public static void makeMap(int P[]){//Put the right values to Map Array
    //Eatch agent has in [Agent][0] his position and the other CW
    //it is a snapshot of the initial (position) configuration
    	InitArray(map);
    	int i=0;
    	for(i=1;i<=k;i++){//for all agents
    			map[i-1]=P[i];	
    	}
    }//end of makeMap
    
    public static void makeD(){//Find the distances between the agents: d1:d[1], d2:d[2] ,d3.. ,d[0] null used later
    	//it the initial distance configuration
    	InitArray(d);
    	int i=-1;
    	for(i=1;i<=k;i++){
    		d[i]=distance(i,mapDirection);
    	}
    }//end of makeD
    
    public static int deadAgent(int P[], int Agent){//return 1 if agents is dead, 0 otherwise
    //input is the agents row of positions Array
    	if(P[BH]==P[Agent]){
    		return 1;}
    	return 0;
    }//end of deadAgent
    
    public static void moveCW( int P[],int pos){ //input array index of agent px 1 for A1
    	if(P[pos]!=P[BH]){
    		if(P[pos]==n2-1){	P[pos]=0;	}
    		else{	P[pos]=P[pos]+1;	}
     	}
    }//end of moveCW
    
 	public static void moveCCW( int P[],int pos){
    	if(P[pos]!=P[BH]){
    		if(P[pos]==0){	P[pos]=n2-1;	}
    		else{	P[pos]=P[pos]-1;	}
     	}
    }//end of moveCCW
    
    public static void move( int P[],int pos, int dir){
    	//uses the ubove 2 functions, dir 1 is CW -1 CCW
    	if(dir>0){moveCW(P,pos);}
    	if(dir<0){moveCCW(P,pos);}
    	if(dir!=1 && dir!=-1){System.out.println("Error: move called with dir="+dir);}
    }
    
 	public static int seeAnotherAgent( int P[],int pos){ //for n agents in the position array
 	//return the number of different Agents at the given node(pos).
 	//if all k agents are at the same node will return k-1
 	//0 if the agent is alone
 		int i=0,agents=0;
 		while(i<P.length){
 			if(i!=pos){
 				if(P[i]==P[pos]){agents=agents+1;}
 			}
 		i++;	
 		}
 		return agents;	
 	}//end of seeAnotherAgent
    
    public static int minID( int P[],int ID){//is the given ID the minimum ID of that node? 1 if yes 0 otherwise
    	if(seeAnotherAgent( P,ID)==1 ){
    		int i=0;
    		while(i<P.length){
    			if(ID!=i){	
    				if(P[ID]==P[i]){
    					if(ID>i){return 0;}
    				}	
    			}
    		i++;
    		}
    		return 1;
    
    	}
    	return 0;
    }//end of minID
    
    public static int smallestID( int P[],int ID){//the min ID at a node, if there are more than one agent
      //return the min of the node for the givens agent node
      //-1 if agent is alone
      if(seeAnotherAgent( P,ID)>0){
    	int i=0;
    	int min=ID;
    	while(i<P.length){
    		if(ID!=i){	
    			if(P[ID]==P[i]){
    				if(min>i){min=i;}
    			}	
    		}
    	i++;
    	}
    	return min;
      }
    	return -1;
    }//end of smallestID
    
    public static int isAgentWithYou( int P[],int posYou, int posAgent){
    	//input:number of the agent asking, and the number of the agent looking for
    	//1 if agents are together at the same node
    	//0 if not
    	int i=0;
 		if(P[posYou]==P[posAgent]){return 1;}
 		else{return 0;} 
    }//end of isAgentWithYou
    
    
//--------------------------Output functions---------------------------------------------------------------------
	//those two functions needed for the printRing, to display agents symbols
	public static int printSymbol(int P[], int start, int end, String s, String s2){
		int flg=0,c=0, f=0;
		for(int i=start;i<=end; i++){
			if(P[BH]==i){System.out.print("M");
			System.out.print(s);}
			else{
				int j=A1;
				while(j<P.length){
					if(P[j]==i){ System.out.printf("%c",'A'+j-1); flg=1; c=c+1;}
				j++;
				}
				if(flg==0){System.out.print(" ");}
				if(c>1){f=1;}
				if( (end-start+1)>1 ){ System.out.print(s2); }
			}
			c=0;		
		}
		return f;
	}
	public static void printRevSymbol(int P[], int start, int end, String s){
		for(int i=start;i>end; i-- ){
			if(P[BH]==i){System.out.print("M" + s);}
			else{
				int j=A1;
				while(j<P.length){
					if(P[j]==i){ System.out.printf("%c",'A'+j-1); }
				j++;
				}
				if( (start-end)>1 ){ System.out.print(s); }
			}	
		}
	}
	
	public static void printRing1( int P[]){
		int i;
		System.out.print("Clock :" + clock +"   -- + --> \n");
		System.out.print("Node :\t");
		for(i=0;i<n2; i++ ){System.out.print(i+"\t\t");}
		System.out.print("\n");
		System.out.print("Agent:\t");
		for(i=0;i<n2; i++ ){
			if(P[BH]==i){System.out.print("M \t\t");}
			else{
				int j=A1;
				while(j<P.length){
					if(P[j]==i){ System.out.printf("%c",'A'+j-1); }
				j++;
				}
				System.out.print("\t\t");
			}	
		}
		System.out.print("\n\n");
	}//end of printRing	
	
	public static void printRing( int P[]){
		int i,n=n2,f=0;
		System.out.print("Clock:" + clock +"   -- + --> \n");
		if(n2%2==0){
		//1st line, node numbers
			System.out.print("\t--\t");
			for(i=1;i<=(n-2)/2; i++ ){System.out.print(i+"\t--\t");}
			
		//2nd line Agent symbols at the ring (if any)
			System.out.print("\n /\t\t");
			if(n2==4){printSymbol(P, 1, (n-2)/2 ,"","\t\t");}
			else{printSymbol(P, 1, (n-2)/2 ,"\t\t","\t\t");}
			if(n2==4){System.out.print("\t\t");}
			System.out.print("\\ \n");						
				
		//3rd line
			System.out.print(0+" ");//prints 0  ...   
			f=printSymbol(P, 0, 0 ,"","\t\t");
			for(i=1;i<=(n-2)/2; i++ ){ 
				System.out.print("\t\t"); 
			}
			if(f==0){
			System.out.print("\t  "); // prin to A or B.. or M and after 5
			printSymbol(P, ((n-2)/2)+1, ((n-2)/2)+1, "" ,"\t\t");
			System.out.print("  ");
			System.out.print( ((n-2)/2)+1 + "\n");  //prints   ...    5
			}else{
				System.out.print("  "); // prin to A or B.. or M and after 5
				printSymbol(P, ((n-2)/2)+1, ((n-2)/2)+1, "" ,"\t\t");
			System.out.print("  ");
			System.out.print( ((n-2)/2)+1 + "\n");  //prints   ...    5
				
				}
		}else{	
		//1st line, node numbers
			System.out.print("\t--\t");
			for(i=1;i<=(n-2)/2+1; i++ ){System.out.print(i+"\t--\t");}
			
		//2nd line Agent symbols at the ring (if any)
			System.out.print("\n /\t\t");
			printSymbol(P, 1, (n-2)/2+1 ,"\t\t","\t\t");
			System.out.print("\\ \n");						
				
		//3rd line
			System.out.print(0+" ");//prints 0  ...   
			printSymbol(P, 0, 0 ,"","\t\t");

			System.out.print("\n");  //prints   ...    half
		}
		
		//4th line
			System.out.print(" \\ \t\t");				
			printRevSymbol(P, n-1, ((n-2)/2)+1,"\t\t");
			if(n2==4){System.out.print("\t\t");}
			System.out.print("/\n");
		
		//5th line
		System.out.print("\t--\t");
		for(i=n-1;i>((n-2)/2)+1; i-- ){System.out.print(i+"\t--\t");}  //prints n n-1 n-2
		System.out.print("\n\t\t");
		System.out.println("\n- - - - - - - - - - - - - - - - - - - - - - - - - - -\n\n");
	}//end of printRing
  
	
//*********************** Algorithm, Procedures and Simulation ***************************************************    
   public static void cautiousWalk(int P[],int Agent,int dir,int AgData[][]){
 			switch (AgData[Agent][0]) {
    case 1: 
    	if(AgData[Agent][2]==0){//min ID initialization
    		AgData[Agent][1]=smallestID(P,Agent); AgData[Agent][2]=1;
    	}
    	if(Agent==AgData[Agent][1]){ //min ID
    		move( P,Agent, AgData[Agent][6]); //move to next node
    	}
    	else {/*Wait*/    	}
    	AgData[Agent][0]=2;
    	break;
    case 2: 
    	if(Agent==AgData[Agent][1]){ //min ID
    		move( P,Agent, AgData[Agent][6]*-1); //return, opposite direction
    	}
    	else {/*Wait*/    	}
    	AgData[Agent][0]=3;
    	break;
    case 3: 
    	if(Agent==AgData[Agent][1]){ //min ID
    		move( P,Agent, AgData[Agent][6]); //move to next node
    	}
    	else {
    		if(AgData[Agent][1]!=-1 && isAgentWithYou(P,Agent,AgData[Agent][1])==1 ){
    			move( P,Agent, AgData[Agent][6]); //move to next node
    		}
    		else{
    			int tt=P[Agent]+dir; if(tt>=n2){tt=0;} if(tt<0){tt=n2-1;} 
    			if(dir>0){System.out.println("Agent:"+Agent+"------>BH CW at node:"+ tt +"\n"); AgData[Agent][8]=1;} 
    			else{System.out.println("Agent:"+Agent+"------>BH CCW at node:"+ tt +"\n"); AgData[Agent][8]=1;}}
    	}
    	AgData[Agent][2]=0;
    	AgData[Agent][0]=1;
    	break;
	}
   }//end of cautiousWalk
     
    public static void MoveTogether(int P[], int Agent, int AgData[][], int segment){
    	//P must be tempPos		segment is one of d1,d2 or d3 for exploration
 		int tt;
 		segment=segment-1;//distance converted to nodes!
 		if(AgData[Agent][7]==0){//phase=0
 			if(segment==2){
 				AgData[Agent][7]=1;
 				AgData[Agent][0]=1;  //<----
 			}
 			if(segment==1){
 				/*BHfound=1;*/ AgData[Agent][8]=1;
 			 	tt=P[Agent]+AgData[Agent][6]; if(tt>=n2){tt=0;} if(tt<0){tt=n2-1;}
 				if(AgData[Agent][6]>0){System.out.println("Agent:"+Agent+"  BH at last node:"+ tt);}
 				if(AgData[Agent][6]<0){System.out.println("Agent:"+Agent+"  BH at last node:"+ tt);}
 			}
 			if(segment>2){
 				if(AgData[Agent][0]==3){
 					AgData[Agent][4]=AgData[Agent][4]-1;
 				}
 				cautiousWalk( P,Agent ,AgData[Agent][6] , AgData);
 			}
 		}
 	  if(AgData[Agent][7]!=0){
 		switch (AgData[Agent][0]){
    		case 1: 
    			if(AgData[Agent][2]==0){ //min ID initialization
    				AgData[Agent][1]=smallestID(P,Agent); AgData[Agent][2]=1;
    			}
    			if(Agent==AgData[Agent][1]){ //min ID
    				move( P,Agent, AgData[Agent][6]); //move to next node
    			}
    			else {/*Wait*/    	}
    			AgData[Agent][0]=2;
    			break;
  			case 2: 
  		  		if(Agent==AgData[Agent][1]){ //min ID
    			move( P,Agent, AgData[Agent][6]*-1); //return, opposite direction
    			}
    			else {/*Wait*/    	}
    			AgData[Agent][0]=3;
    			break;
    		case 3: 
    			if(Agent==AgData[Agent][1]){ //min ID
    				System.out.println("-->The other agent will be updated\n");
    			int e;
    			for(e=1;e<=k;e++){AgData[e][8]=1; //all agents know that the BH has been found (not the location of the BH)
    				if(deadAgent(P,e)==0){
    				tt=P[Agent]+AgData[Agent][6]+AgData[Agent][6]; //for right output
    				if(tt>=n2){ if(tt==n2){tt=0;} if(tt>n2){tt=1;}	} 
    				if(tt<=-1){ if(tt==-1){tt=n2-1;} if(tt<-1){tt=n2-2;} }
    				if(AgData[Agent][6]>0){System.out.println("Agent:"+e+"---------->BH CW at:"+ tt); AgData[Agent][8]=1;} 
    				else{	  System.out.println("Agent:"+e+"---------->BH CCW at:"+ tt ); AgData[Agent][8]=1;}
    				}
    			}
    			BHfound=1;
    			
    			}
    			else {
 
    			if(AgData[Agent][1]!=-1 && isAgentWithYou(P,Agent,AgData[Agent][1])==1 ){
    				move( P,Agent, AgData[Agent][6]); //move to next node
    			}
    			else{
    				tt=P[Agent]+AgData[Agent][6]; if(tt>=n2){tt=0;} if(tt<0){tt=n2-1;}
    				if(AgData[Agent][6]>0){System.out.println("Agent:"+Agent+"------>BH CW at node:"+ tt +"\n");
    				  System.out.println();
    				  AgData[Agent][8]=1;} 
    				else{	  System.out.println("Agent:"+Agent+"------>BH CCW at node:"+ tt +"\n"); AgData[Agent][8]=1;}}
    			}
    			AgData[Agent][2]=0;
    			AgData[Agent][0]=1;
    			break;
 		}
 	  }
	}//MoveTogether
    	
    public static void AgentAlgorithm(int P[],int map[], int d[],int Agent, long phase ,int AgData[][], int tempP[], int mapDir){
    	//input: the curent positions of agents for the changes of one agent at a time
    	//map the iniitial positions af agents, AgentID the agent calls the algorithm
    	//y-> 0 phase of CWalk 1 MINid  	2 flag for MINid 3 flag for wait,move or MoveTogether
    	//    4 delay 		   5 Algphase  	6 dir  			 7 MoveT phase
    	//delay: steps for wait, move or MoveTogether
    	//clock will be the phase!
      if(AgData[Agent][3]==0){//no waiting flag exists
		if(AgData[Agent][5]<2){//phase<2
    		switch (Agent){
    		case 1:  //you are agent1: 
		  		if(AgData[Agent][5]<2){
					if(d[0]>0){
					AgData[Agent][3]=1;  //flag, wait d time units;
					AgData[Agent][4]=d[0]; //delay time d
					}
					AgData[Agent][5]=2;
		  		}
				break;
			case 2:  //you are agent2:
/*ph=0*/  		if(AgData[Agent][5]==0){
					if(d[1]>0){//move d1 steps at counterclockwise direction;
						AgData[Agent][3]=2; //flag for move
						AgData[Agent][4]=d[1];  //steps - delay
						AgData[Agent][6]=-1*mapDir;   //direction
						//AgData[Agent][6]=-1;   //direction
						AgData[Agent][5]=1;	//phase
					}
				break;
		  		}
/*ph=1*/  		if(AgData[Agent][5]==1){
					if(d[0]-d[1]>0){
						AgData[Agent][3]=1;  //flag, wait d-d1 time units;
						AgData[Agent][4]=d[0]-d[1];   //delay wait d-d1 time units;
				}else{AgData[Agent][3]=0;}	//phase}  <---changed
				 AgData[Agent][5]=2;	//phase
		  		}
			 	break;
			case 3: // you are agent3
/*ph=0*/ 		if(AgData[Agent][5]==0){
					if(d[3]>0){//move d3 steps at clockwise direction;
						AgData[Agent][3]=2; //flag for move
						AgData[Agent][4]=d[3];  //steps - delay
						AgData[Agent][6]=1*mapDir;   //direction
						//AgData[Agent][6]=1;   //direction
						AgData[Agent][5]=1;	//phase
					}
					break;
		 		}
/*ph=1*/  		if(AgData[Agent][5]==1){				
					if(d[0]-d[3]>0){//wait d-d3 time units;
						AgData[Agent][3]=1;  //flag, wait d-d1 time units;
						AgData[Agent][4]=d[0]-d[3];   //delay wait d-d1 time units;
					}
				AgData[Agent][5]=2;	//phase
				}
				break;
    		}//end of switch1 
		}
      	if(AgData[Agent][5]==2 && AgData[Agent][3]==0){ //2<=phase<4
      		if( seeAnotherAgent(P,Agent)==k-1 ){
			    if(d[2]-1==1){ System.out.println("Agent:" +Agent+ " BH at the one node of d2:"+ (map[A2-1]+1)); AgData[Agent][8]=1;; }
      		  	if(AgData[Agent][5]==2){ //phase is 2
      				if(d[1]<=d[3]){//move d1 steps CW
      					AgData[Agent][3]=2; //flag for move
						AgData[Agent][4]=d[1];  //steps - delay
						AgData[Agent][6]=1*mapDir;   //direction
						//AgData[Agent][6]=1;   //direction
						AgData[Agent][5]=3;	//phase
      				}else{//move d3 steps CCW
      					AgData[Agent][3]=2; //flag for move
						AgData[Agent][4]=d[3];  //steps - delay
						AgData[Agent][6]=-1*mapDir;   //direction
						//AgData[Agent][6]=-1;   //direction
						AgData[Agent][5]=3;	//phase      			
      				}
      		  	}
      		  }else{ AgData[Agent][5]=4; } //next phase, phase = 4 
      	}
      	if(AgData[Agent][5]==3 && AgData[Agent][3]==0){//phase will be 3   <--
      		  	//call moveT with d2
      		  	AgData[Agent][3]=3; //flag for MoveT
				AgData[Agent][4]=d[2];  //distance for exploration
				AgData[Agent][5]=10;	//phase 10 for catching errors
      	}
      	if(AgData[Agent][5]>=4 && AgData[Agent][3]==0 && AgData[Agent][5]<10){//phase will be 4   <--
      		if(Agent==A1){
      			if( isAgentWithYou(P,Agent,A2)==1 ){
      				AgData[Agent][6]=-1*mapDir;
      				//AgData[Agent][6]=-1;
      				//call moveT (with d3)
      				AgData[Agent][3]=3; //flag for MoveT
					AgData[Agent][4]=d[3];  //distance for exploration
					AgData[Agent][5]=10;	//phase 10 for catching errors
      			}
      			if( isAgentWithYou(P,Agent,A3)==1 ){
      				//call moveT (with d1)
      				AgData[Agent][6]=1*mapDir;
      				//AgData[Agent][6]=1;
      				AgData[Agent][3]=3; //flag for MoveT
					AgData[Agent][4]=d[1];  //distance for exploration
					AgData[Agent][5]=10;	//phase 10 for catching errors
      			}
      		    }else{
      				if(Agent==A2){//call moveT (with d3)
      					AgData[Agent][3]=3; //flag for MoveT
						AgData[Agent][4]=d[3];  //distance for exploration
						AgData[Agent][5]=10;	//phase 10 for catching errors
      				}
      				if(Agent==A3){//call moveT (with d1)
      					AgData[Agent][3]=3; //flag for MoveT
						AgData[Agent][4]=d[1];  //distance for exploration
						AgData[Agent][5]=10;	//phase 10 for catching errors
      				}
      			}
      		if(AgData[Agent][5]==10 && AgData[Agent][3]==0){ System.out.println("ERROR should has stopped");  }
      	}
      }//END of flag 0
	  if(AgData[Agent][3]==1){//flag will be 1, wait for the delay
    		if(AgData[Agent][4]>0) {  AgData[Agent][4]=AgData[Agent][4]-1; }
    		if(AgData[Agent][4]==0){  AgData[Agent][3]=0;   			   }
      }//end of flag 1
      
      if(AgData[Agent][3]==2){//flaf will be 2, move for the delay-steps
	  	if(AgData[Agent][4]>0){
	  		AgData[Agent][4]=AgData[Agent][4]-1;
	  		move(tempP,Agent,AgData[Agent][6]);
	  	}
	  	if(AgData[Agent][4]==0){ AgData[Agent][3]=0; }
	  }//end of flag 2
	  
	  if(AgData[Agent][3]==3){//flag will be 3, call d times MoveTogether
	  		if(AgData[Agent][4]>0){
	  			//MoveT will decrease d!!
	  			MoveTogether( tempP, Agent, AgData, AgData[Agent][4]);
	  		}
	  		if(AgData[Agent][4]==0){ AgData[Agent][3]=0;  }
	  }//end of flag 3
   
   }//end of Algorithm
    	
    public static void simulationAll(int P[],int AgData[][], int tempPos[]){
    	int i,t;
    	int threshold=400;   //threshold is the maximum number of clock cycle: prevent simulation running for infinity
		for(t=1;t<k+1;t++){AgData[t][0]=1;} //for all agents the init state is the same: phse=1
		makeMap(P);
		makeD();
		d[0]=MAX(d[1],d[3]);
		
		//-----Simulation output data:-----------------------------------------------------
		System.out.println("Map distances: {Max(d1,d3), A->B, B->C, C->A }");	
		PrintArray(d);
		System.out.println("Agents positions at the map: {A1 A2 A3}");
 		PrintArray(map);

		System.out.println("Initial positions");
		if(PrintMethod==1){printRing(P);}else{printRing1(P);}
		//-------------------------------------------------------------------------------	
    	
    	int contFlag=0;
		while(BHfound==0 && contFlag!=1 && clock<threshold){//stops after #threshold steps!!!
			i=0;
			for(i=k;i>0;){
				  if(deadAgent(P,i)==0){
				  	AgentAlgorithm(P, map, d, i    , clock ,AgData, tempPos, mapDirection);
				  }
				  i--;
			}
			BHfound=1;
			for(i=1;i<=k;i++){
				if(deadAgent(P,i)==0){
					if(AgData[i][8]==0){ BHfound=0; }
				} 
			}
			if(BHfound!=1){
				UpdatePos(tempPos, P);
				clock=clock+1;
				if(PrintMethod==1){printRing(P);}else{printRing1(P);}
			}
			if(contFlag==0 ){
				System.out.printf("continue?? ( Yes(0)/No(1)/Auto(2)  )");
				contFlag=Uinput();
			}
		}
    }//end of simulationAll
    

    
        
}//end of Agents3
